import { buildUUID } from '../../../../utils/uuid';
//import { ApiAction, ApiActionPage } from '../../model/baseModel';
import { genAction, Api } from '../../system';
import { useUserStore } from '/@/store/modules/user';
import { defHttp } from '/@/utils/http/axios';
import { isNullOrEmpty } from '/@/utils/is';
import { formatToDateTime } from '/@/utils/dateUtil';

/*
 * 获取工具保养项目
 */

export const getListByPage = async (params: any) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.FEEDER_CODE != undefined && params?.FEEDER_CODE != '') {
    sqlcmd += " And FEEDER_CODE like '%" + params?.FEEDER_CODE + "%'";
  }

  let option = {
    UserId: useUserStore().getUserInfo.userId as string,
    ByOrg: true,
    OrgCode: useUserStore().getUserInfo.orgCode as string
  }
  if (!isNullOrEmpty(params.page)) {
    const usParams = genAction('SMT_MT_PROJECT', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      }
    });
    return getListByPageAsync(usParams);
  } else {
    const usParams = genAction('SMT_MT_PROJECT', {
      QueryAble_T: '',
      where: sqlcmd
    });
    return getListByPageAsync(usParams);
  }
  // const rParams = genActionPage('BIZ_ERP_PROD_IN', sqlcmd, params.page, params.pageSize,option);
  // return getFinishedwarehouseListByPageAsync(rParams);
};
async function getListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {}
  if (isNullOrEmpty(data.Data.page)) {
    model = {
      items: data.Data.Items,
    };
  } else {
    model = {
      items: data.Data.page.data,
      total: data.Data.page.totals,
    };
  }
  return model;
}
//新增飞达信息
export const Save = async (params: Recordable, isUpdate: boolean, isbaofei: boolean) => {
  const item: any = {
    ID: params.ID,
    CREATE_TIME: params?.CREATE_TIME,
    CREATE_USER: params?.CREATE_USER,
    UPDATE_TIME: params?.UPDATE_TIME,
    UPDATE_USER: params?.UPDATE_USER,
    GHOST_ROW: params?.GHOST_ROW,
    AUTH_ORG: params?.AUTH_ORG,
    AUTH_PROD: params?.AUTH_PROD,
    AUTH_WH: params?.AUTH_WH,
    PROJ_CODE: params?.PROJ_CODE,
    PROJ_NAME: params?.PROJ_NAME,
    TOOL_TYPE: params?.TOOL_TYPE,
    ITEM01: params?.ITEM01,
    ITEM02: params?.ITEM02,
    ITEM03: params?.ITEM03,
    ITEM04: params?.ITEM04,
    ITEM05: params?.ITEM05,
    ITEM06: params?.ITEM06,
    ITEM07: params?.ITEM07,
    ITEM08: params?.ITEM08,
    ITEM09: params?.ITEM09,
    ITEM10: params?.ITEM10,
    ITEM11: params?.ITEM11,
    ITEM12: params?.ITEM12,
    ITEM13: params?.ITEM13,
    ITEM14: params?.ITEM14,
    ITEM15: params?.ITEM15,
    ITEM16: params?.ITEM16,
    ITEM17: params?.ITEM17,
    ITEM18: params?.ITEM18,
    ITEM19: params?.ITEM19,
    ITEM20: params?.ITEM20,
    
    REMARK: params?.REMARK,
  };
  let data;

  if (isUpdate) {
    if (isbaofei) {
      item.STATUS = 5;
    }
    const time = new Date();
    item.UPDATE_TIME = formatToDateTime(time);
    item.UPDATE_USER = useUserStore().getUserInfo.userId as string;
    // regionitem.ORG_CODE = useUserStore().getUserInfo.orgCode as string;
    // regionitem.AUTH_ORG = useUserStore().getUserInfo.orgCode as string;
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('SMT_MT_PROJECT', item) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    // const usParams = genAction(
    //   'SMT_SOLDER',
    //   "REGION_CODE='" + params.REGION_CODE + "'AND AUTH_ORG='" + regionitem.ORG_CODE + "'",
    // );
    //var check = await isExist(usParams);
    //console.log('check',check)
    //if (!check.Data) {
    item.ID = buildUUID(); //生成GUID
    item.UPDATE_TIME = formatToDateTime(new Date());
    item.CREATE_USER = useUserStore().getUserInfo.userId as string;
    item.UPDATE_USER = useUserStore().getUserInfo.userId as string;
    // regionitem.ORG_CODE = useUserStore().getUserInfo.orgCode as string;
    // regionitem.AUTH_ORG = useUserStore().getUserInfo.orgCode as string;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('SMT_MT_PROJECT', item) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
    //} else {
    // return check.Message;
    //return '重复了';
    //}
  }
  return data;
};
//删除
export const Delete = async (Tool_Id: string) => {
  const usParams = genAction('SMT_MT_PROJECT', `ID='${Tool_Id}'`)
  return await defHttp.post(
    { url: Api.DeleteWhere, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false
    }
  )
}
//下拉列表
// STATUSs 单据状态
export const optionsListApi = async (params: Recordable) => {
  const usParams = genAction('V_SMT_TOOL+ALARM_TYPEs', '');
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
};
//类型
export const optionsListApiType = async (params: Recordable) => {
  const usParams = genAction('V_SMT_TOOL+TYPEs', '');
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
};